=== debian/changelog ===
ats-lang-anairiats (0.2.4-1) unstable; urgency=low

  * New upstream release

 -- Matthew Danish <mrd@debian.org>  Mon, 25 Apr 2011 12:53:22 -0400
